# ../addons/eventscripts/client_keypress/client_keypress.py

""" IMPORTS """
import es
import keyfile

import spe


""" INFORMATIONS """
informations = es.AddonInfo()
informations.name = "Client KeyPress"
informations.basename = "client_keypress"
informations.version = "1.4"
informations.author = "L'In20Cible"
informations.description = "Provides an event fired when a player press/unpress some keys."
informations.url = "http://addons.eventscripts.com/addons/view/client_keypress/"

es.ServerVar("client_keypress_version", informations.version + " by " + informations.author, informations.description).makepublic()


""" GLOBALS """
players = dict()


""" INITIALIZATION """
def load():
    Initialization()
    es.addons.registerTickListener(TickListenerCallBack)
    es.loadevents("declare", "addons/eventscripts/client_keypress/resource/events.res")
    
def Initialization():
    global offset, buttons
    games = keyfile.Parse(es.getAddonPath(informations.basename) + "/resource/games.cfg")[es.getGameName()]
    offset = games["#offsets"]["m_nButtons"]["windows"]
    if spe.platform != "nt":
        offset = games["#offsets"]["m_nButtons"]["linux"]
    offset = int(offset)
    buttons = games["#buttons"]
    for button in buttons:
        buttons[button] = int(buttons[button])
    es.loadevents("addons/eventscripts/client_keypress/resource/events.res")
    
def unload():
    es.addons.unregisterTickListener(TickListenerCallBack)
    
    
""" METHODS """
def fireEvent(userid, keyname, status):
    es.event("initialize", "client_keypress")
    es.event("setint", "client_keypress", "userid", userid)
    es.event("setstring", "client_keypress", "keyname", keyname)
    es.event("setint", "client_keypress", "status", 1 if status else 0)
    es.event("fire", "client_keypress")
    
    
""" CALLBACKS """
def TickListenerCallBack():
    for userid in es.getUseridList():
        m_nButtons = spe.getLocVal("i", spe.getPlayer(userid) + offset)
        if userid not in players:
            players[userid] = m_nButtons
        for button in buttons:
            if m_nButtons & buttons[button] and not players[userid] & buttons[button]:
                fireEvent(userid, button, True)
            elif players[userid] & buttons[button] and not m_nButtons & buttons[button]:
                fireEvent(userid, button, False)
        players[userid] = m_nButtons
        
        
""" EVENTS """
def es_map_start(event_var):
    Initialization()
    
def player_disconnect(event_var):
    userid = int(event_var["userid"])
    if userid in players:
        del players[userid]